using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.ExcelRW;
using System.IO;

namespace CreatingASimpleSpreadsheet
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(88, 32);
			this.button1.Name = "button1";
			this.button1.TabIndex = 0;
			this.button1.Text = "Create XLS";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(264, 86);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.button1});
			this.Name = "Form1";
			this.Text = "Evaluation Center Samples";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			//New instance of XlsIO is created.[Equivalent to launching MS Excel with no workbooks open].
			//The instantiation process consists of two steps.

			//Step 1 : Instantiate the spreadsheet creation engine.
			ExcelEngine excelEngine = new ExcelEngine();
			//Step 2 : Instantiate the excel application object.
			IApplication application = excelEngine.Excel;
			
			//A new workbook is created.[Equivalent to creating a new workbook in MS Excel]
			// The number of default worksheets is the application setting in MS Excel.
			IWorkbook workbook = excelEngine.Excel.Workbooks.Create(5);
			IWorksheet sheet = workbook.Worksheets[0];

            sheet.Range["A1"].Number = 120;
            sheet.Range["A2"].Number = 10;
            sheet.Range["A3"].Number = 150;
            sheet.Range["A4"].Number = 23;
           
			//AVERAGE (Returns the Average of the Range)
            sheet.Range["B1"].Formula = "SUBTOTAL(1,A1:A2)";
			//COUNT (Returns the Count of the Range)
           	sheet.Range["B2"].Formula = "SUBTOTAL(2,A1:A3)" ;
			//COUNTA (Returns the Count of the Range)
			sheet.Range["B3"].Formula = "SUBTOTAL(3,A1:A4)" ;
			//MAX (Returns Maximum value of the Range)
			sheet.Range["B4"].Formula = "SUBTOTAL(4,A1:A4)";
			//MIN (Returns Minimum value of the Range)
			sheet.Range["B5"].Formula = "SUBTOTAL(5,A1:A4)";
			//PRODUCT (Returns the Product of the Range)
			sheet.Range["B6"].Formula = "SUBTOTAL(6,A1:A2)";
			//STDEV (Returns the Standard Deviation of based on a sample of numbers)
			sheet.Range["B7"].Formula = "SUBTOTAL(7,A1:A2)";
			//STDEVP (Returns the Standard Deviation of Population based on an entire population of numbers)
			sheet.Range["B8"].Formula = "SUBTOTAL(8,A1:A2)";
			//SUM (Returns the Sum of the Range)
			sheet.Range["B9"].Formula = "SUBTOTAL(9,A1:A4)";
			//VAR (Returns the Variance based on a sample of numbers)
			sheet.Range["B10"].Formula = "SUBTOTAL(10,A1:A4)";
			//VARP (Returns the Variance of Population based on an entire population of numbers)
			sheet.Range["B11"].Formula = "SUBTOTAL(11,A1:A4)";

			
        	//Saving the workbook to disk.
		    workbook.SaveAs("Sample.xls");
			//No exception will be thrown if there are unsaved workbooks. No use here since we are
			// saving the workbook.
			excelEngine.ThrowNotSavedOnDestroy = true;
			excelEngine.Dispose();  
			//Launching the Excel file using the default Application.[MS Excel Or Free ExcelViewer]
			System.Diagnostics.Process.Start("Sample.xls");		
		}
	}
}
